//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "eFijarVencimientos.h"
#include "QrRecibos.h"
#include "QrUnRecibo.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TeRecibos *eRecibos;
//---------------------------------------------------------------------------
__fastcall TeRecibos::TeRecibos(TComponent* Owner)
        : TForm(Owner)
{
 TbRecibos->TableName ="datos\\recibos.db";
 TbRecibos->Active = true;
}
//---------------------------------------------------------------------------

void __fastcall TeRecibos::ToolButton1Click(TObject *Sender)
{
 Close();        
}
//---------------------------------------------------------------------------
void __fastcall TeRecibos::TbRecibosCalcFields(TDataSet *DataSet)
{
 AnsiString cadena;
 Currency importe = TbRecibos->FieldByName("Importe")->AsCurrency;
 int aux;

 // Si el importe es mayor de mil (obtenemos solo los millares)
 cadena = "";
 aux = importe;
 if ( aux >= 1000 )
 {
        if ( ( aux/1000 ) == 1 )
          cadena += "mil ";
        else
          cadena += entero2txt( (aux/1000) ) + " mil ";
 }
 if ( aux >= 1 )
 {
        cadena += entero2txt( (aux%1000) ) + " uros";
        aux = importe*100;
        if ( (aux%100) )
                cadena += " con ";

 }
 aux = (importe*100);
 aux %= 100;
 if ( aux )
 {
   TbRecibos->FieldByName("ImporteTXTcent")->AsString = entero2txt( aux ) + " centimos";
 }

 TbRecibos->FieldByName("ImporteTXT")->AsString = cadena;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TeRecibos::entero2txt(int num)
{

 AnsiString dev;

 switch( (num/100)%10 )
 {
  case 1:
                        if ( (num % 100)==(num%10) && (num%10)==0 )
                                dev = "cien";
                        else
                                dev = "ciento ";

                        break;
  case 2:           dev += "doscientos ";        break;
  case 3:           dev += "trescientos ";        break;
  case 4:           dev += "cuatrocientos ";        break;
  case 5:           dev += "quinientos ";        break;
  case 6:           dev += "seiscientos ";        break;
  case 7:           dev += "setecientos ";        break;
  case 8:           dev += "ochocientos ";        break;
  case 9:           dev += "novecientos ";        break;
 }

 switch( (num/10)%10 )
 {
  case 1:
                   switch( num%10 )
                   {
                        case 0: dev += "diez "; break;
                        case 1: dev += "once "; break;
                        case 2: dev += "doce "; break;
                        case 3: dev += "trece "; break;
                        case 4: dev += "catorce "; break;
                        case 5: dev += "quince "; break;
                        case 6: dev += "diesiceis "; break;
                        case 7: dev += "diecisiete "; break;
                        case 8: dev += "dieciocho "; break;
                        case 9: dev += "diecinueve "; break;
                   }
                    break;
  case 2:           dev += "veinte ";        break;
  case 3:           dev += "treinta ";        break;
  case 4:           dev += "cuarenta ";        break;
  case 5:           dev += "cincuenta ";        break;
  case 6:           dev += "sesenta ";        break;
  case 7:           dev += "setenta ";        break;
  case 8:           dev += "ochenta ";        break;
  case 9:           dev += "noventa ";        break;
  if ( num%10 ) dev += "y ";
 }

 if ( ((num/10)%10) != 1 )
         switch( (num%10) )
         {
          case 1:           dev += "uno";         break;
          case 2:           dev += "dos";        break;
          case 3:           dev += "tres";        break;
          case 4:           dev += "cuatro";        break;
          case 5:           dev += "cinco";        break;
          case 6:           dev += "seis";        break;
          case 7:           dev += "siete";        break;
          case 8:           dev += "ocho";        break;
          case 9:           dev += "nueve";        break;
         }

 return dev;
}
//---------------------------------------------------------------------------
void __fastcall TeRecibos::BitBtn2Click(TObject *Sender)
{
  TbRecibos->Filter = "[FechaVencimiento]>="+FechaMin->Date+" AND [FechaVencimiento]<="+FechaMax->Date;
  TbRecibos->Filtered = true;
}
//---------------------------------------------------------------------------
void __fastcall TeRecibos::DBGrid1DblClick(TObject *Sender)
{
  PageControl1->ActivePage = EmisionRecibos;        
}
//---------------------------------------------------------------------------
void __fastcall TeRecibos::BitBtn1Click(TObject *Sender)
{
  if ( TbRecibos->State == dsInsert )
  {
          TfijarVencimientos *Venc;
          Venc = new TfijarVencimientos(this);
          Venc->ShowModal();
          delete Venc;
  }
}
//---------------------------------------------------------------------------
void __fastcall TeRecibos::BitBtn3Click(TObject *Sender)
{
 TQRListRecibos *LR;
 LR = new TQRListRecibos(this);
 LR->MasterTable->TableName = TbRecibos->TableName;
 LR->MasterTable->Filter = TbRecibos->Filter;
 LR->MasterTable->Filtered = TbRecibos->Filtered;
 LR->MasterTable->Active = true;
 LR->QuickRep1->ReportTitle = "Listados de Recibos entre: " + FechaMin->Date.DateString() + " y " + FechaMax->Date.DateString();
 LR->QuickRep1->Preview();
 delete LR;
}
//---------------------------------------------------------------------------
void __fastcall TeRecibos::BitBtn4Click(TObject *Sender)
{
 TQrRecibo *R;
 R = new TQrRecibo(this);
 R->QuickRep1->Print();
 delete R;
}
//---------------------------------------------------------------------------


